/**
 * ModelZombieVillager - Either Mojang or a mod author Created using Tabula
 * 7.0.0
 */
public static class ModelZombieVillager extends ModelBase {
	public ModelRenderer field_178723_h;
	public ModelRenderer field_178721_j;
	public ModelRenderer field_78116_c0;
	public ModelRenderer field_78116_c1;
	public ModelRenderer field_78115_e0;
	public ModelRenderer field_78115_e1;
	public ModelRenderer field_178724_i;
	public ModelRenderer field_178722_k;
	public ModelRenderer field_178720_f;

	public ModelZombieVillager() {
		this.textureWidth = 64;
		this.textureHeight = 64;
		this.field_178722_k = new ModelRenderer(this, 0, 22);
		this.field_178722_k.mirror = true;
		this.field_178722_k.setRotationPoint(2.0F, 12.0F, 0.10000000149011612F);
		this.field_178722_k.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, 0.0F);
		this.field_178720_f = new ModelRenderer(this, 32, 0);
		this.field_178720_f.setRotationPoint(0.0F, 0.0F, 0.0F);
		this.field_178720_f.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, 0.5F);
		this.field_78116_c1 = new ModelRenderer(this, 24, 0);
		this.field_78116_c1.setRotationPoint(0.0F, 0.0F, 0.0F);
		this.field_78116_c1.addBox(-1.0F, -3.0F, -6.0F, 2, 4, 2, 0.0F);
		this.field_178723_h = new ModelRenderer(this, 44, 38);
		this.field_178723_h.setRotationPoint(-5.0F, 2.0F, 0.0F);
		this.field_178723_h.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, 0.0F);
		this.setRotateAngle(field_178723_h, -1.3962634801864624F,
				-0.10000000149011613F, 0.10000000149011613F);
		this.field_178724_i = new ModelRenderer(this, 44, 38);
		this.field_178724_i.mirror = true;
		this.field_178724_i.setRotationPoint(5.0F, 2.0F, 0.0F);
		this.field_178724_i.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, 0.0F);
		this.setRotateAngle(field_178724_i, -1.3962634801864624F,
				0.10000000149011613F, -0.10000000149011613F);
		this.field_178721_j = new ModelRenderer(this, 0, 22);
		this.field_178721_j
				.setRotationPoint(-2.0F, 12.0F, 0.10000000149011612F);
		this.field_178721_j.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, 0.0F);
		this.field_78116_c0 = new ModelRenderer(this, 0, 0);
		this.field_78116_c0.setRotationPoint(0.0F, 0.0F, 0.0F);
		this.field_78116_c0.addBox(-4.0F, -10.0F, -4.0F, 8, 10, 8, 0.0F);
		this.field_78115_e0 = new ModelRenderer(this, 16, 20);
		this.field_78115_e0.setRotationPoint(0.0F, 0.0F, 0.0F);
		this.field_78115_e0.addBox(-4.0F, 0.0F, -3.0F, 8, 12, 6, 0.0F);
		this.field_78115_e1 = new ModelRenderer(this, 0, 38);
		this.field_78115_e1.setRotationPoint(0.0F, 0.0F, 0.0F);
		this.field_78115_e1.addBox(-4.0F, 0.0F, -3.0F, 8, 18, 6,
				0.04999961890280247F);
	}

	@Override
	public void render(Entity entity, float f, float f1, float f2, float f3,
			float f4, float f5) {
		this.field_178722_k.render(f5);
		this.field_178720_f.render(f5);
		this.field_78116_c1.render(f5);
		this.field_178723_h.render(f5);
		this.field_178724_i.render(f5);
		this.field_178721_j.render(f5);
		this.field_78116_c0.render(f5);
		this.field_78115_e0.render(f5);
		this.field_78115_e1.render(f5);
	}

	/**
	 * This is a helper function from Tabula to set the rotation of model parts
	 */
	public void setRotateAngle(ModelRenderer modelRenderer, float x, float y,
			float z) {
		modelRenderer.rotateAngleX = x;
		modelRenderer.rotateAngleY = y;
		modelRenderer.rotateAngleZ = z;
	}

	public void setRotationAngles(float f, float f1, float f2, float f3,
			float f4, float f5, Entity e) {
		super.setRotationAngles(f, f1, f2, f3, f4, f5, e);
		this.field_178721_j.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
		this.field_178722_k.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F
				* f1;
	}
}
