package net.mcreator.nightmarish_kingdom;

import net.minecraft.world.gen.structure.template.Template;
import net.minecraft.world.gen.structure.template.PlacementSettings;
import net.minecraft.world.WorldServer;
import net.minecraft.world.World;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.math.ChunkPos;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.Rotation;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.Mirror;
import net.minecraft.item.ItemStack;
import net.minecraft.init.Blocks;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.Entity;
import net.minecraft.block.state.IBlockState;
import net.minecraft.block.Block;

import java.util.HashMap;

@Elementsnightmarish_kingdom.ModElement.Tag
public class MCreatorNKDimensionPlayerEntersDimension extends Elementsnightmarish_kingdom.ModElement {
	public MCreatorNKDimensionPlayerEntersDimension(Elementsnightmarish_kingdom instance) {
		super(instance, 46);
	}

	public static void executeProcedure(java.util.HashMap<String, Object> dependencies) {
		if (dependencies.get("entity") == null) {
			System.err.println("Failed to load dependency entity for procedure MCreatorNKDimensionPlayerEntersDimension!");
			return;
		}
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure MCreatorNKDimensionPlayerEntersDimension!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure MCreatorNKDimensionPlayerEntersDimension!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure MCreatorNKDimensionPlayerEntersDimension!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure MCreatorNKDimensionPlayerEntersDimension!");
			return;
		}
		Entity entity = (Entity) dependencies.get("entity");
		int x = (int) dependencies.get("x");
		int y = (int) dependencies.get("y");
		int z = (int) dependencies.get("z");
		World world = (World) dependencies.get("world");
		entity.getEntityData().setDouble("NumberDimensionJoin", ((entity.getEntityData().getDouble("NumberDimensionJoin")) + 1));
		if (((entity.getEntityData().getDouble("NumberDimensionJoin")) == 1)) {
			if ((Math.random() < 0.25)) {
				{
					if (world.isRemote)
						return;
					Template template = ((WorldServer) world).getStructureTemplateManager().getTemplate(world.getMinecraftServer(),
							new ResourceLocation("nightmarish_kingdom", "morzaron_tower"));
					if (template == null)
						return;
					BlockPos spawnTo = new BlockPos((int) (x + 250), (int) y, (int) z);
					IBlockState iblockstate = world.getBlockState(spawnTo);
					world.notifyBlockUpdate(spawnTo, iblockstate, iblockstate, 3);
					template.addBlocksToWorldChunk(world, spawnTo, new PlacementSettings().setRotation(Rotation.NONE).setMirror(Mirror.NONE)
							.setChunk((ChunkPos) null).setReplacedBlock((Block) null).setIgnoreStructureBlock(false).setIgnoreEntities(false));
				}
			} else if ((Math.random() < 0.25)) {
				{
					if (world.isRemote)
						return;
					Template template = ((WorldServer) world).getStructureTemplateManager().getTemplate(world.getMinecraftServer(),
							new ResourceLocation("nightmarish_kingdom", "morzaron_tower"));
					if (template == null)
						return;
					BlockPos spawnTo = new BlockPos((int) (x - 250), (int) y, (int) z);
					IBlockState iblockstate = world.getBlockState(spawnTo);
					world.notifyBlockUpdate(spawnTo, iblockstate, iblockstate, 3);
					template.addBlocksToWorldChunk(world, spawnTo, new PlacementSettings().setRotation(Rotation.NONE).setMirror(Mirror.NONE)
							.setChunk((ChunkPos) null).setReplacedBlock((Block) null).setIgnoreStructureBlock(false).setIgnoreEntities(false));
				}
			} else if ((Math.random() < 0.25)) {
				{
					if (world.isRemote)
						return;
					Template template = ((WorldServer) world).getStructureTemplateManager().getTemplate(world.getMinecraftServer(),
							new ResourceLocation("nightmarish_kingdom", "morzaron_tower"));
					if (template == null)
						return;
					BlockPos spawnTo = new BlockPos((int) x, (int) y, (int) (z + 250));
					IBlockState iblockstate = world.getBlockState(spawnTo);
					world.notifyBlockUpdate(spawnTo, iblockstate, iblockstate, 3);
					template.addBlocksToWorldChunk(world, spawnTo, new PlacementSettings().setRotation(Rotation.NONE).setMirror(Mirror.NONE)
							.setChunk((ChunkPos) null).setReplacedBlock((Block) null).setIgnoreStructureBlock(false).setIgnoreEntities(false));
				}
			} else {
				{
					if (world.isRemote)
						return;
					Template template = ((WorldServer) world).getStructureTemplateManager().getTemplate(world.getMinecraftServer(),
							new ResourceLocation("nightmarish_kingdom", "morzaron_tower"));
					if (template == null)
						return;
					BlockPos spawnTo = new BlockPos((int) x, (int) y, (int) (z - 250));
					IBlockState iblockstate = world.getBlockState(spawnTo);
					world.notifyBlockUpdate(spawnTo, iblockstate, iblockstate, 3);
					template.addBlocksToWorldChunk(world, spawnTo, new PlacementSettings().setRotation(Rotation.NONE).setMirror(Mirror.NONE)
							.setChunk((ChunkPos) null).setReplacedBlock((Block) null).setIgnoreStructureBlock(false).setIgnoreEntities(false));
				}
			}
			if (((entity.getEntityData().getBoolean("KillMorzaron")) == (false))) {
				if (entity instanceof EntityPlayerMP)
					MCreatorDimensionEnterA.trigger.triggerAdvancement((EntityPlayerMP) entity);
				if (entity instanceof EntityPlayer && !world.isRemote) {
					((EntityPlayer) entity)
							.sendStatusMessage(
									new TextComponentString(
											"You are now in The Nightmarish Kingdom. Now, I hope that you are ready because you can\u2019t go back to your world anymore. If you want to find your world, you have to go at the top of the Morzaron\u2019s Tower, fight him, and finally kill him, but before, try to a village of this kingdom, speak with locals, and finish your full armor. I suggest to you to have your armor Tier IV, and some relics before fight Morzaron, otherwise you will die and our kingdom will be destroyed forever. Don\u2019t go find Morzaron now please."),
									(false));
				}
				if ((!((entity instanceof EntityPlayer) ? ((EntityPlayer) entity).capabilities.isCreativeMode : false))) {
					if (entity instanceof EntityPlayer)
						((EntityPlayer) entity).inventory.clearMatchingItems(new ItemStack(MCreatorNKDimension.block, (int) (1)).getItem(), -1,
								(int) 1, null);
					world.setBlockState(new BlockPos((int) x, (int) y, (int) z), Blocks.AIR.getDefaultState(), 3);
				}
			}
		}
	}
}
