package net.mcreator.nightmarish_kingdom;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;

import net.minecraft.world.gen.feature.WorldGenAbstractTree;
import net.minecraft.world.biome.Biome;
import net.minecraft.util.math.BlockPos;
import net.minecraft.init.Blocks;

import java.util.Random;

@Elementsnightmarish_kingdom.ModElement.Tag
public class MCreatorNightmarishKingdomBiome extends Elementsnightmarish_kingdom.ModElement {
	@GameRegistry.ObjectHolder("nightmarish_kingdom:nightmarishkingdombiome")
	public static final BiomeGenCustom biome = null;

	public MCreatorNightmarishKingdomBiome(Elementsnightmarish_kingdom instance) {
		super(instance, 44);
	}

	@Override
	public void initElements() {
		elements.biomes.add(() -> new BiomeGenCustom());
	}

	@Override
	public void init(FMLInitializationEvent event) {
	}

	static class BiomeGenCustom extends Biome {
		public BiomeGenCustom() {
			super(new Biome.BiomeProperties("The Nightmarish Kingdom").setRainfall(0.5F).setBaseHeight(0.1F).setWaterColor(-16761233)
					.setHeightVariation(0.2F).setTemperature(0.6F));
			setRegistryName("nightmarishkingdombiome");
			topBlock = Blocks.GRASS.getDefaultState();
			fillerBlock = Blocks.DIRT.getDefaultState();
			decorator.generateFalls = false;
			decorator.treesPerChunk = 1;
			decorator.flowersPerChunk = 1;
			decorator.grassPerChunk = 1;
			decorator.deadBushPerChunk = 3;
			decorator.mushroomsPerChunk = 1;
			decorator.bigMushroomsPerChunk = 0;
			decorator.reedsPerChunk = 0;
			decorator.cactiPerChunk = 0;
			decorator.sandPatchesPerChunk = 1;
			decorator.gravelPatchesPerChunk = 2;
		}

		@SideOnly(Side.CLIENT)
		@Override
		public int getGrassColorAtPos(BlockPos pos) {
			return -13601792;
		}

		@SideOnly(Side.CLIENT)
		@Override
		public int getFoliageColorAtPos(BlockPos pos) {
			return -13601792;
		}

		@SideOnly(Side.CLIENT)
		@Override
		public int getSkyColorByTemp(float currentTemperature) {
			return -12279553;
		}

		@Override
		public WorldGenAbstractTree getRandomTreeFeature(Random rand) {
			return BIG_TREE_FEATURE;
		}
	}
}
